#!/usr/bin/env node
import r from "chalk";
import m from "node:path";
import u from "node:fs";
import I from "json5";
import h from "lodash.upperfirst";
import x from "lodash.camelcase";
import E from "lodash.kebabcase";
import L from "lodash.lowerfirst";
import d from "lodash.template";
import w from "prompts";
import { OutputModeEnum as $, handler as C, onPromptFormStateForSigint as O } from "@done-coding/cli-template";
import k from "yargs";
import { hideBin as T } from "yargs/helpers";
import D from "lodash.curry";
var i = /* @__PURE__ */ ((e) => (e.ADD = "add", e.REMOVE = "remove", e.LIST = "list", e))(i || {});
const _ = (e, t) => {
  if (!/^[a-zA-Z]+[a-zA-Z0-9-]*$/.test(e))
    return console.log(r.red("组件名只能包含字母、数字、中划线")), process.exit(1);
  const { nameExcludes: o } = t;
  return o.includes(e) ? (console.log(
    r.red(`组件名: ${e}是保留名称。
保留名称: ${o.join(",")}`)
  ), process.exit(1)) : !0;
}, f = {
  version: "0.2.2",
  name: "@done-coding/cli-component",
  description: "组件命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "component"
  }
}, { namespaceDir: j, moduleName: A } = f.cliConfig, M = () => m.resolve(j, A), N = () => ({
  execDir: process.cwd(),
  templateDir: M()
}), g = (e) => {
  const { series: t, name: o } = e, s = h(x(o)), c = L(s), a = E(s), l = t ? h(x(t)) : "", n = l ? `${l}${s}` : "", p = E(n);
  return {
    series: l,
    name: s,
    nameLowerFirst: c,
    nameKebab: a,
    fullName: n,
    fullNameKebab: p,
    cls: p
  };
}, K = (e) => ({
  $: "$",
  ...N(),
  ...g(e)
}), v = () => {
  const e = m.resolve(M(), "index.json");
  if (!u.existsSync(e))
    return console.log(r.red(`模块入口文件不存在: ${e}`)), process.exit(1);
  const o = JSON.parse(u.readFileSync(e, "utf-8")).config;
  if (!o)
    return console.log(r.red(`配置文件相对路径不存在: ${o}`)), process.exit(1);
  const s = m.resolve(
    m.dirname(e),
    o
  );
  if (!u.existsSync(s))
    return console.log(r.red(`配置文件不存在: ${s}`)), process.exit(1);
  const c = I.parse(u.readFileSync(s, "utf-8")), a = N();
  return c.componentDir = d(c.componentDir)(a), c;
}, y = (e) => {
  const { componentDir: t, nameExcludes: o } = e;
  return u.statSync(t).isDirectory() ? u.readdirSync(t).map((l) => {
    const n = m.join(t, l);
    return u.statSync(n).isDirectory() ? (console.log("filePath:", n, m.basename(n)), m.basename(n)) : "";
  }).filter((l) => !(!l || o.includes(l))) : (console.log(r.red("组件源码路径不是目录")), process.exit(1));
}, U = async () => {
  console.log(r.blue("展示列表"));
  const e = v(), t = y(e);
  console.table(
    t.map((o) => {
      const { name: s, fullName: c } = g({
        ...e,
        name: o
      });
      return {
        [r.green("名称")]: s,
        [r.green("带系列名称")]: c,
        [r.green("绝对路径")]: m.resolve(e.componentDir, o)
      };
    })
  );
}, R = async ({
  name: e,
  config: t,
  command: o
}) => {
  if (![i.ADD, i.REMOVE].includes(o))
    return console.log(r.red(`不支持组件${o}操作`)), process.exit(1);
  const s = K({
    ...t,
    name: e
  }), c = JSON.stringify(s);
  for (const { entry: a, index: l } of t.list) {
    if (a) {
      const n = a;
      n != null && n.input && (n.input = d(n.input)(s)), n != null && n.output && (n.output = d(n.output)(s));
      const p = {
        ...a,
        envData: c,
        mode: $.APPEND,
        rollback: o === i.REMOVE,
        dealMarkdown: !0
      };
      await C(p);
    }
    if (l) {
      const n = l;
      n != null && n.input && (n.input = d(n.input)(s)), n != null && n.output && (n.output = d(n.output)(s));
      const p = {
        ...l,
        envData: c,
        mode: $.OVERWRITE,
        rollback: o === i.REMOVE,
        dealMarkdown: !0
      };
      await C(p);
    }
  }
}, z = async ({ name: e }) => {
  console.log(r.blue("添加组件"));
  let t;
  e ? t = e : t = (await w({
    type: "text",
    name: "name",
    message: "请输入组件名",
    onState: O
  })).name;
  const o = v();
  _(t, o);
  const { series: s } = o, c = await y(o);
  for (let a of c)
    if (g({
      series: s,
      name: t
    }).nameKebab === a)
      return console.log(r.red(`组件${a}已存在, 不能再次创建${t}组件`)), process.exit(1);
  return R({
    name: t,
    config: o,
    command: i.ADD
  });
}, H = async ({ name: e }) => {
  console.log(r.blue("移除组件"));
  const t = v(), o = await y(t);
  if (o.length === 0)
    return console.log(r.red("组件列表为空")), process.exit(1);
  let s;
  e ? s = e : s = (await w({
    type: "select",
    name: "name",
    message: "请选择要移除的组件",
    choices: o.map((a) => ({ title: a, value: a })),
    onState: O
  })).name;
  const { series: c } = t;
  for (let a of o)
    if (g({
      series: c,
      name: s
    }).nameKebab === a) {
      await R({
        name: s,
        config: t,
        command: i.REMOVE
      }), u.rmdirSync(m.resolve(t.componentDir, a));
      return;
    }
  return console.log(r.red(`组件${s}不存在`)), process.exit(1);
}, b = async (e, t) => e === i.ADD ? z(t) : e === i.REMOVE ? H(t) : e === i.LIST ? U() : (console.log(r.red(`无效的命令: ${e}`)), process.exit(1)), P = async (e) => {
}, V = f.cliConfig.moduleName, J = (e, t) => {
  console.log(e ? r.red(e) : r.red(t.message)), process.exit(1);
}, Z = f.description, B = `Usage: $0 ${V} <command> [options]`, W = "Usage: $0 <command> [options]", S = (e) => e.command({
  command: `${i.ADD} <name>`,
  describe: "新增一个组件",
  builder: (t) => t.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  async handler(t) {
    return await D(b)(i.ADD)(t), process.exit(0);
  }
}).command({
  command: `${i.REMOVE} [name]`,
  describe: "删除一个组件",
  builder: (t) => t.positional("name", {
    describe: "组件名称",
    type: "string"
  }),
  async handler(t) {
    return await D(b)(i.REMOVE)(t), process.exit(0);
  }
}).command({
  command: i.LIST,
  describe: "展示组件列表",
  async handler(t) {
    return await D(b)(i.LIST)(t), process.exit(0);
  }
}).demandCommand(1), F = (e, t = !1) => t ? S(e.strict().usage(B)) : S(
  e.strict().usage(W).help("help").version(f.version).alias("v", "version").alias("h", "help")
).fail(J).argv, q = (e) => F(e, !0), ue = {
  command: V,
  describe: Z,
  builder: q,
  handler: P
}, pe = async () => {
  const e = k(T(process.argv));
  return await F(e), P();
};
export {
  ue as a,
  pe as c,
  P as h
};
